package main

import (
	"log"
	"os"
	"time"

	fronttime "srs.epita.fr/fic-server/frontend/time"
	"srs.epita.fr/fic-server/settings"
)

var startedFile = "started"

var touchTimer *time.Timer = nil

func touchStartedFile() {
	if fd, err := os.Create(startedFile); err == nil {
		log.Println("Started! Go, Go, Go!!")
		fd.Close()
	} else {
		log.Fatal("Unable to start challenge:", err)
	}
}

func reloadSettings(config settings.FICSettings) {
	if fronttime.ChallengeStart != config.Start || fronttime.ChallengeEnd != config.End {
		if touchTimer != nil {
			touchTimer.Stop()
		}
		startSub := config.Start.Sub(time.Now())
		if startSub > 0 {
			log.Println("Challenge will starts at", config.Start, "in", startSub)

			if _, err := os.Stat(startedFile); !os.IsNotExist(err) {
				os.Remove(startedFile)
			}

			touchTimer = time.AfterFunc(config.Start.Sub(time.Now().Add(time.Duration(1 * time.Second))), touchStartedFile)
		} else {
			log.Println("Challenge started at", config.Start, "since", -startSub)
			touchStartedFile()
		}
		log.Println("Challenge ends on", config.End)

		fronttime.ChallengeStart = config.Start
		fronttime.ChallengeEnd = config.End
	} else {
		log.Println("Configuration reloaded, but start/end times doesn't change.")
	}

	enableResolutionRoute = config.EnableResolutionRoute
	denyNameChange = config.DenyNameChange
	allowRegistration = config.AllowRegistration
}
